<?php 
/**
 * Класс Webp - предназначен для конвертирования изображений в формат webp
 *
 * Реализован в виде синглтона, что исключает его дублирование.
 *
 * @author Шевченко Александр Станиславович
 * @package moguta.cms
 * @subpackage Libraries
 */

 class Webp{
    static private $_instance = null;
	public static $retutn = true;
    private function __construct(){
        self::getInstance();
    }

    /**
     * Возвращает единственный экземпляр данного класса.
     * @access private
     * @return object объект класса LoggerAction.
     */
    static public function getInstance() {
        if(is_null(self::$_instance)) {
          self::$_instance = new self;
        }
        return self::$_instance;
    }

    /*
    * Метод для подсчета кол-ва изображений (общее)
    */

    public static function getCountImg($dir, $startTime, $recourse = false){
        $files = scandir($dir);
        $maxExecTime = min(30, @ini_get("max_execution_time"));
        if (empty($maxExecTime)) {
          $maxExecTime = 30;
        }
        // Пробегаем по директории
        foreach ($files as $key => $file){
          $execTime = microtime(true) - $startTime;
          if($execTime + 5 >= $maxExecTime){
			      self::$retutn = false;
            return $_SESSION['DIR'];
          }
          $fullfilename = $dir . DS . $file;
          if ($file == '.' || $file == '..' || $file == 'temp' || $file == 'webp' || (isset($_SESSION['FILES_OBR'][dirname($fullfilename)]) && in_array($file, $_SESSION['FILES_OBR'][dirname($fullfilename)]))) continue;
          // Записывает в массив те папки, которые обошли 
          if (is_dir($fullfilename)) {
            $_SESSION['DIR'] = $fullfilename;
            $_SESSION['FILES_OBR'][dirname($fullfilename)][] = basename($fullfilename);
            // Запускаем метод внутрь папки
            self::getCountImg($fullfilename, $startTime, true);
          }else{
            if(preg_match('/(.jpg|.jpeg|.png)$/is', $fullfilename) 
				      && (!isset($_SESSION['FILES_OBR'][$fullfilename]) || !in_array(basename($fullfilename), $_SESSION['FILES_OBR'][$fullfilename]))){
              // Считаем кол-во изображений и записываем их, что посчитали уже
              $_SESSION['COUNT']++;
              $_SESSION['FILES_OBR'][dirname($fullfilename)][] = basename($fullfilename);
            }
          }
        }
        // удаляем директроию и файлы, которые прошли
        if(self::$retutn){
          unset($_SESSION['FILES_OBR'][dirname($fullfilename)]);
        }
        if((!$recourse && (dirname($fullfilename) == SITE_DIR || dirname(dirname($fullfilename)) == SITE_DIR || strpos(dirname(dirname($fullfilename)), 'uploads') == false)) || empty($_SESSION['FILES_OBR'])){
          return 'true';
        }
        if(!$recourse){
          self::getCountImg(dirname(dirname($fullfilename)), $startTime, false);
        }
        return $_SESSION['DIR'];
    }

    /*
    * Метод для конвертации изображений (общее)
    */
    public static function convertImgToWebp($dir, $startTime, $recourse = false){
      $files = scandir($dir);
      $maxExecTime = min(30, @ini_get("max_execution_time"));
      if (empty($maxExecTime)) {
        $maxExecTime = 30;
      }
      foreach ($files as $key => $file){
        $execTime = microtime(true) - $startTime;
        if($execTime + 5 >= $maxExecTime){
  	      self::$retutn = false;
          return $_SESSION['DIR'];
        }
        $fullfilename = $dir . DS . $file;
        if ($file == '.' || $file == '..' || $file == 'temp' || $file == 'webp' || (isset($_SESSION['FILES_OBR'][dirname($fullfilename)]) && in_array($file, $_SESSION['FILES_OBR'][dirname($fullfilename)]))) continue;
        if (is_dir($fullfilename)) {
          if ($file === 'prodtmpimg') {
            continue;
          }
          $_SESSION['DIR'] = $fullfilename;
          $_SESSION['FILES_OBR'][dirname($fullfilename)][] = basename($fullfilename);
          self::convertImgToWebp($fullfilename, $startTime, true);
        }else{
          if(preg_match('/(.jpg|.jpeg|.png)$/is', $fullfilename) 
				    && (!isset($_SESSION['FILES_OBR'][$fullfilename]) || !in_array(basename($fullfilename), $_SESSION['FILES_OBR'][$fullfilename]))){
              $dirOfImg = str_replace(SITE_DIR.'uploads'.DS, '', dirname($fullfilename));
              // пути к изображениям в папке uploads
              if(basename($dirOfImg) == 'uploads'){
                $webpImgPath = SITE_DIR.'uploads'.DS.'webp'.DS;
              }
              // остальные пути
              else{
                if(!is_dir('uploads'.DS.'webp'.DS.$dirOfImg)){
                  mkdir('uploads'.DS.'webp'.DS.$dirOfImg, 0755, true);
                }
                $webpImgPath = SITE_DIR.'uploads'.DS.'webp'.DS.$dirOfImg.DS;
              }
              $webpImgPath .= preg_replace('/(.jpg|.jpeg|.png)$/is', '.webp', basename($fullfilename));
              $imgPath = $fullfilename;
              $pathInfo = strtolower(pathinfo($fullfilename, PATHINFO_EXTENSION));	
              // процесс конвертации ( только для тех файлов)
              if(!file_exists($webpImgPath)){
                if($pathInfo == 'jpeg' || $pathInfo == 'jpg'){
                  $img = imagecreatefromjpeg($imgPath);	
                }else if($pathInfo == 'png'){
                  $img = imagecreatefrompng($imgPath);
                  imagepalettetotruecolor($img);
                  imagealphablending($img, true);
                  imagesavealpha($img, true);
                }
                imagewebp($img, $webpImgPath);				  
              }             
              $_SESSION['COUNT_CONVERT']++;
              $_SESSION['FILES_OBR'][dirname($fullfilename)][] = basename($fullfilename);
            }
          }
      }
      if(self::$retutn){
        unset($_SESSION['FILES_OBR'][dirname($fullfilename)]);
      }
      if((!$recourse && (dirname($fullfilename) == SITE_DIR || dirname(dirname($fullfilename)) == SITE_DIR || strpos(dirname(dirname($fullfilename)), 'uploads') == false)) || empty($_SESSION['FILES_OBR'])){
        return 'true';
      }
      if(!$recourse){
        self::convertImgToWebp(dirname(dirname($fullfilename)), $startTime, false);
      }
      return $_SESSION['DIR']; 
    }
	  
	/**
     * Преобразует изображения в webp
     * @param string $content html верстка компонетна
     * @return string
     */
    
    public static function changeImgForWebp($content){
      mg::loger($content);
      //Парсим регуляркой все изображения
      /*
      $regEx = '@[="|=\'|\(]( *[\.d\:|\\s\w+\+\-\/]*[\-\w]+\.(?>jpg|png|jpeg).*?)[\"|\'|\)]@S';
      */  
      $regEx = '@[="|=\'|\(]( *[\.d\:|\\s\w+\+\-\/]*[\-\w\,№!\@\#\$\%\^\&\*)\(]+\.(?>jpg|png|jpeg)).*?[\"|\'|\)]@S';
      preg_match_all($regEx, $content, $mathes, PREG_PATTERN_ORDER);
      if(!empty($mathes[1])){
        foreach($mathes[1] as $match){
          if(strpos($match, 'uploads') !== false){
            // Преобразовываем урл в массив
            $urlSec = URL::getSections($match);
            $fullLinkArray = array();
            foreach($urlSec as $urlPaths){
              $fullLinkArray[] = $urlPaths;
              // Добавляем папку webp в будущую ссылку
              if($urlPaths == 'uploads'){
                $fullLinkArray[] = 'webp';
              }
            }
            $img = array_pop($fullLinkArray);
            // Заменяем расширение на webp
            $img = preg_replace('/(.jpg|.png|.jpeg)/is', '.webp', $img);
            array_push($fullLinkArray, $img);
            $fullLink = trim(implode('/', $fullLinkArray));
            $filePath = substr($fullLink, strpos($fullLink, 'uploads'));
            //Проверяем, есть ли у нас такой файл
            if(file_exists($filePath)){
              $content = str_replace($match, $fullLink, $content);
            }
          }
        }
      }
      return $content;
    }

	  /**
     * Заменяет ссылку изображения на картинку webp. Если такой картинки нет, вернет ссылку обратно
     * @param string $imgUrl - заменяемый url
     * @return string 
     */
    public static function changeImg($imgUrl){
      $changeImgUrl = preg_replace('/(.jpg|.png|.jpeg)/is', '.webp', $imgUrl);
      $changeImgUrl = str_replace('uploads', '', substr($changeImgUrl, strpos($changeImgUrl, 'uploads')));
      $imgUrlNew = SITE.DS.'uploads'.DS.'webp'.$changeImgUrl;
      $dirImg = SITE_DIR.'uploads'.DS.'webp'.$changeImgUrl;
      if(file_exists($dirImg)){
        return $imgUrlNew;
      }else{
        return $imgUrl;
      }
    }

    /**
     * Проверяет, поддерживает ли браузер формат webp
     * @return bool 
     */
    public static function checkUserBrowser(){
      if(strpos( $_SERVER['HTTP_ACCEPT'], 'image/webp' ) !== false ) {
        return true;
      }else{
        return false;
      }     
    }

    /**
     * Создает изображение в формате webp для определенной картинки
     * @param string $content html верстка компонетна
     * @return bool 
     */
    public static function createWebpImg($imgUrl){
      if(function_exists('imagewebp') && MG::getSetting('useWebpImg') == 'true'){
        @set_time_limit(0);
        list($width_uploaded, $height_uploaded) = getimagesize($imgUrl);
        $maxUploadWidth = MG::getSetting('maxUploadImgWidth');
        if (!$maxUploadWidth) {$maxUploadWidth = 1500;}
        $maxUploadHeight = MG::getSetting('maxUploadImgHeight');
        if (!$maxUploadHeight) {$maxUploadHeight = 1500;}

        if ($width_uploaded > $maxUploadWidth || $height_uploaded > $maxUploadHeight) {
          return false;
        }
        $dirOfImg = str_replace(SITE_DIR.'uploads'.DS, '', dirname($imgUrl));
        $dirArr = explode(DS, $dirOfImg);

        if(!is_dir('uploads'.DS.'webp')){
          mkdir('uploads'.DS.'webp', 0755, true);
        }
        $mainDir = 'uploads'.DS.'webp';
        foreach($dirArr as $dir){
          if(!is_dir($mainDir.DS.$dir)){
            mkdir($mainDir.DS.$dir, 0755, true);
          }
          $mainDir = $mainDir.DS.$dir;
        }
        $webpImgPath = SITE_DIR.$mainDir.DS;
        $webpImgPath .= preg_replace('/(.jpg|.jpeg|.png)$/is', '.webp', basename($imgUrl));
        $pathInfo = pathinfo($imgUrl, PATHINFO_EXTENSION);
        
        if(!file_exists($webpImgPath)){
          if($pathInfo == 'jpeg' || $pathInfo == 'jpg'){
            $img = imagecreatefromjpeg($imgUrl);	
          }else if($pathInfo == 'png'){
            $img = imagecreatefrompng($imgUrl);
            imagepalettetotruecolor($img);
            imagealphablending($img, true);
            imagesavealpha($img, true);
          }
          imagewebp($img, $webpImgPath);				  
        }
        return true;  
      }else{
        return false;
      }
    }
       

 }