<?php

/*
	Plugin Name: Товар дня
	Description: Отображает товара дня на месте шорткода [daily-product]
	Author: Nikita F
	Version: 1.2.2
 */

new dailyProduct;

class dailyProduct{

	private static $pluginName = ''; // название плагина (соответствует названию папки)
	private static $path = '';//путь к плагину
	private static $options = array();
	private static $cache = array();

	public function __construct() {

		mgActivateThisPlugin(__FILE__, array(__CLASS__, 'activate')); //Активация плагина
		mgAddAction(__FILE__, array(__CLASS__, 'pageSettingsPlugin')); //Настройки плагина
		mgAddShortcode('daily-product', array(__CLASS__, 'shortCode'));//шорткод плагина
		self::$pluginName = PM::getFolderPlugin(__FILE__);//имя плагина
		//У плагина из шаблона путь будет немного другой
		self::$path = 'mg-templates/'.MG::getOption('templateName').DS.PLUGIN_DIR.self::$pluginName;
		mgAddMeta('<script src="'.SITE.'/'.self::$path.'/js/TimeCircles.js"></script>');
		mgAddMeta('<script src="'.SITE.'/'.self::$path.'/js/public.js"></script>');
		mgAddMeta('<link rel="stylesheet" href="'.SITE.'/'.self::$path.'/css/TimeCircles.css" type="text/css" />');
		mgAddMeta('<link rel="stylesheet" href="'.SITE.'/'.self::$path.'/css/style.css" type="text/css" />');

		if (// хуки для скидок
			method_exists('Models_Catalog', 'modUserFilterNavigatorSql') &&
			method_exists('Models_Catalog', 'modFilterMinMaxPrices')
			) {
			mgAddAction('Models_Catalog_getListByUserFilter', array(__CLASS__, 'hook_getListByUserFilter'),1,1);
			mgAddAction('Models_Product_getProduct', array(__CLASS__, 'hook_getProduct'),1,1);
			mgAddAction('Models_Catalog_getList', array(__CLASS__, 'hook_getList'),1,1);
			mgAddAction('Models_Catalog_getListProductByKeyWord', array(__CLASS__, 'hook_getList'),1,1);

			mgAddAction('Models_Catalog_modUserFilterNavigatorSql', array(__CLASS__, 'hook_modUserFilterNavigatorSql'),1,1);
			mgAddAction('Models_Catalog_modFilterMinMaxPrices', array(__CLASS__, 'hook_modFilterMinMaxPrices'),1,1);

			mgAddAction('Models_Cart_applycoupon', array(__CLASS__, 'hook_applyCoupon'), 1,99);
                        mgAddAction('Models_Cart_customPrice', array(__CLASS__, 'hook_getItemsCart'),1,1);
                        
                        if (!method_exists('Models_Cart', 'applyDiscountSystem')) {
				mgAddAction('Models_Cart_getTotalSumm', array(__CLASS__, 'hook_getTotalSumm'),1,99);
				mgAddAction('Models_Cart_applydiscountsystem', array(__CLASS__, 'hook_applyDiscountSystem'), 1,99);
			}
		}
	}

	static function activate(){
		
		if (!MG::getOption('dailyProduct')) {
			$res = DB::query("SELECT `id` FROM `".PREFIX."product` WHERE `old_price` > `price` ORDER BY RAND() LIMIT 0,1");
			if ($row = DB::fetchAssoc($res)) {
				$id = $row['id'];
			}
			else{
				$id = '';
			}
			$arr = array(
				'currentProductId' 	=> $id,
				'nextUpdateTime' 	=> strtotime(date('Y-m-d 00:00:00')) + 86400,// +1 день
				'updateOffset' 		=> 0,
				'blockWidth' 		=> 251,
				'header' 			=> 'ТОВАР ДНЯ',
				'body' 				=> 'До окончания предложения:',
				'updateType' 		=> 'all',
				'direction'			=> 'Counter-clockwise',
				'angle' 			=> 0,
				'imgHeight' 		=> 300,
				'labelSize' 		=> 8,
				'labelLineSize' 	=> 0,
				'numberSize' 		=> 24,
				'numberLineSize' 	=> 10,
				'cats' 				=> array(),
				'list' 				=> array(),
				'listNum' 			=> 'none',
				'useTimer' 			=> 'true',
				'animation' 		=> 'smooth',
				'circleWidth' 		=> '0.02',
				'bgWidth' 			=> '0.1',
				'bgColor' 			=> 'cccccc',
				'hourText' 			=> 'час',
				'hourColor' 		=> 'f9af39',
				'hourColorLabel' 	=> '333333',
				'hourColorNumber' 	=> '333333',
				'minuteText' 		=> 'мин',
				'minuteColor' 		=> 'f9af39',
				'minuteColorLabel' 	=> '333333',
				'minuteColorNumber' => '333333',
				'secondText' 		=> 'сек',
				'secondColor' 		=> 'f9af39',
				'secondColorLabel' 	=> '333333',
				'secondColorNumber' => '333333',
				'linkColor' 		=> '000000',
				'oldPriceColor' 	=> '000000',
				'newPriceColor' 	=> 'cd4449',
				'headerColor' 		=> '000000',
				'descriptionColor' 	=> '000000',
				'randomDiscount' 	=> 0,
				'ignoreDiscounts' 	=> 'true',
				);
			MG::setOption(array('option' => 'dailyProduct', 'value' => addslashes(serialize($arr))));
		}
	}

	static function pageSettingsPlugin() {//Вывод страницы плагина в админке
		echo '   
			<link rel="stylesheet" href="'.SITE.'/'.self::$path.'/css/style.css" type="text/css" />
			<link rel="stylesheet" href="'.SITE.'/'.self::$path.'/css/TimeCircles.css" type="text/css" />
		 	<link rel="stylesheet" href="'.SITE.'/mg-core/script/colorPicker/css/layout.css" type="text/css" />     
      		<link rel="stylesheet" href="'.SITE.'/mg-core/script/colorPicker/css/colorpicker.css" type="text/css" /> 

			<script>
				includeJS("'.SITE.'/'.self::$path.'/js/script.js");  
			</script> 
		';

		$pluginName = self::$pluginName;

		$options = self::updateTimer();

		$model = new Models_Catalog;
		$arrayCategories = $model->categoryId = MG::get('category')->getHierarchyCategory(0);
		$categoriesOptions = MG::get('category')->getTitleCategory($arrayCategories, URL::get('category_id'));

		$model = new Models_Product;
		$product = $model->getProduct($options['currentProductId']);
		$options['prodImg'] = SITE.'/uploads/'.$product['image_url'];
		$options['prodUrl'] = SITE.'/'.$product['category_url'].'/'.$product['product_url'];
		$options['prodTitle'] = $product['title'];

		$prices = self::calcCurrentDiscount($product['price_course'], $product['old_price']);
		$currs = MG::getSetting('currencyShort');
		$iso = MG::getSetting('currencyShopIso');
		$curr = $currs[$iso];

		$options['prodPrice'] = MG::numberFormat($prices['price']).' '.$curr;
		$options['prodOldPrice'] = MG::numberFormat($prices['oldPrice']).' '.$curr;

		$path = self::$path;
		$exampleName = '';
		$res = DB::query("SELECT `title` FROM `".PREFIX."product` WHERE `old_price` > `price` ORDER BY RAND() LIMIT 0,1");
		if ($row = DB::fetchAssoc($res)) {
			$exampleName = $row['title'];
		}

		if (// хуки для скидок
			method_exists('Models_Catalog', 'modUserFilterNavigatorSql') &&
			method_exists('Models_Catalog', 'modFilterMinMaxPrices')
			) {
			$printDiscounts = true;
		} else {
			$printDiscounts = false;
		}

		include 'pageplugin.php';
	}

	public static function getLang($locale){
		$path = self::$path.'/locales/'.$locale.'_'.strtoupper($locale).'.php';
	
		if (in_array($locale, self::listLocales()) && file_exists($path)) {
		  include($path);
		} else {
		  include(self::$path.'/locales/ru_RU.php');
		}
	
		return $lang;
	  }
	
	public static function listLocales() {
		$locales = array_diff(scandir(self::$path.'/locales/'), array('.','..'));

		$langs = array();
		foreach ($locales as $key => $filename) {
			$tmp = explode("_", $filename);
	      	$langs[] = $tmp[0];
		}

		return $langs;
	}

	static function shortCode(){//функция шорткода
		$lang = self::getLang(LANG);
		$html = MG::get('dailyProductOptions');

		if ($html == null) {
			$options = self::updateTimer();

			if (!strlen($options["header"])) {
				$options["header"] = $lang['HEAD'];
			}

			if (!strlen($options["body"])) {
				$options["body"] = $lang['BODY'];
			}

			if (!strlen($options["hourText"])) {
				$options["hourText"] = $lang['HOUR_TEXT'];
			}

			if (!strlen($options["minuteText"])) {
				$options["minuteText"] = $lang['MINUTE_TEXT'];
			}

			if (!strlen($options["secondText"])) {
				$options["secondText"] = $lang['SECOND_TEXT'];
			}

			if ($options['updateType'] == 'list' && $options['listNum'] !== 0 && $options['listNum'] == 'none') {
				return false;
			}

			$model = new Models_Product;
			$product = $model->getProduct($options['currentProductId']);

			if (empty($product['title'])) {
				$options = self::updateTimer(true);
				$product = $model->getProduct($options['currentProductId']);

				if (empty($product['title'])) {
					return false;
				}
			}

			$curr = MG::getSetting('currencyShort');
			$iso = MG::getSetting('currencyShopIso');
			$curr = $curr[$iso];
			
			$options['prodImg'] = mgImageProductPath($product['image_url'], $product['id'], 'big');
			$options['prodUrl'] = SITE.'/'.$product['category_url'].'/'.$product['product_url'];
			if (MG::getSetting('shortLink')=='true') {
				$options['prodUrl'] = SITE.'/'.$product['product_url'];
			}
			$options['prodTitle'] = $product['title'];
			$options['prodPrice'] = MG::numberFormat($product['price_course']).' '.$curr;
			$options['prodOldPrice'] = MG::numberFormat($product['old_price']).' '.$curr;
			$html = '<div class="dailyProduct" style="width: '.$options["blockWidth"].'px;">';
			if (strlen($options["header"])) {$html .= '<div style="color:#'.$options['headerColor'].'" class="dailyTitle">'.$options["header"].'</div>';}
			if (strlen($options["body"])) {$html .= '<div style="color:#'.$options['descriptionColor'].'" class="dailyMessage">'.$options["body"].'</div>';}
			if ($options["useTimer"] == 'true') {

				$html .= '<div class="dailyTimer" 
				data-animation="'.$options["animation"].'" 
				data-bgwidth="'.$options["bgWidth"].'" 
				data-circlewidth="'.$options["circleWidth"].'" 
				data-bgcolor="'.$options["bgColor"].'" 
				data-direction="'.$options["direction"].'" 
				data-angle="'.$options["angle"].'" 
				data-hourtext="'.$options["hourText"].'" 
				data-hourcolor="'.$options["hourColor"].'" 
				data-minutetext="'.$options["minuteText"].'" 
				data-minutecolor="'.$options["minuteColor"].'" 
				data-secondtext="'.$options["secondText"].'" 
				data-secondcolor="'.$options["secondColor"].'" 
				data-labelsize="'.$options["labelSize"].'" 
				data-numbersize="'.$options["numberSize"].'" 
				data-hourcolorlabel="'.$options["hourColorLabel"].'" 
				data-hourcolornumber="'.$options["hourColorNumber"].'" 
				data-minutecolorlabel="'.$options["minuteColorLabel"].'" 
				data-minutecolornumber="'.$options["minuteColorNumber"].'" 
				data-secondcolorlabel="'.$options["secondColorLabel"].'" 
				data-secondcolornumber="'.$options["secondColorNumber"].'" 
				data-labellinesize="'.$options["labelLineSize"].'" 
				data-numberlinesize="'.$options["numberLineSize"].'" 
				style="width:inherit !important;" data-date="'.
					date("Y-m-d H:i:s", ($options['nextUpdateTime'] + 1200*$options['updateOffset'])).'"></div>';
			}

			if ($options['prodOldPrice'] > 0) {
				$oldPrice = '<span style="color:#'.$options['oldPriceColor'].'" class="old">'.$options['prodOldPrice'].'</span>';
			} else {
				$oldPrice = '';
			}
						
			$html .= '<a class="dailyImg" target="_blank" href="'.$options['prodUrl'].'"><img alt="'.$product['title'].'" style="max-height: '.$options['imgHeight'].'px;" src="'.$options['prodImg'].'"></a><br>
					<a class="dailyLink" style="color:#'.$options['linkColor'].'" target="_blank" href="'.$options['prodUrl'].'">'.$options['prodTitle'].'</a><br>
					<div class="dailyPrice">'.$oldPrice.' <span style="color:#'.$options['newPriceColor'].'" class="new">'.$options['prodPrice'].'</span></div>
					</div>';
			MG::set('dailyProductOptions', $html);
		}

    	return $html;
	}

	static function selectNewProduct($updateType, $oldId, $cats = false){//выбор нового товара
		$options = self::updateTimer();

		if (isset($options['randomDiscount']) && $options['randomDiscount']) {
			$where = '';
		} else {
			$where = '`old_price` > `price` AND ';
		}

    	switch ($updateType) {
    		case 'recomended':
    			$res = DB::query("SELECT `id` FROM `".PREFIX."product` WHERE ".$where."`recommend` = 1 AND `id` <> ".DB::quoteInt($oldId)." ORDER BY RAND() LIMIT 0,1");
				$row = DB::fetchAssoc($res);
				return $row['id'];
    			break;
    		case 'new':
    			$res = DB::query("SELECT `id` FROM `".PREFIX."product` WHERE ".$where."`new` = 1 AND `id` <> ".DB::quoteInt($oldId)." ORDER BY RAND() LIMIT 0,1");
				$row = DB::fetchAssoc($res);
				return $row['id'];
    			break;
    		case 'cats':
    			if (is_array($cats)) {
    			  if (count($cats) > 0) {
              //$cats = implode(', ', $cats);

              $res = DB::query("SELECT `id` FROM `".PREFIX."product` WHERE ".$where."`id` <> ".DB::quoteInt($oldId)." AND `cat_id` IN (".DB::quoteIN($cats).") ORDER BY RAND() LIMIT 0,1");
              $row = DB::fetchAssoc($res);
              return $row['id'];
            }
    			} else{
    				$res = DB::query("SELECT `id` FROM `".PREFIX."product` WHERE ".$where."`id` <> ".DB::quoteInt($oldId)." ORDER BY RAND() LIMIT 0,1");
					$row = DB::fetchAssoc($res);
					return $row['id'];
    			}
    			break;
    		
    		default:
    			$res = DB::query("SELECT `id` FROM `".PREFIX."product` WHERE ".$where."`id` <> ".DB::quoteInt($oldId)." ORDER BY RAND() LIMIT 0,1");
				$row = DB::fetchAssoc($res);
				return $row['id'];
    			break;
    	}
	}

	static function updateTimer($forceUpdate = false){//выбор нового времени и товара

		if (!empty(self::$options) && !$forceUpdate) {
			return self::$options;
		}

		self::$options = unserialize(stripslashes(MG::getSetting('dailyProduct')));

		$oldTime = self::$options['nextUpdateTime'];
		$newTime = strtotime(date('Y-m-d 00:00:00')) + 86400;// +1 день

		if ($newTime > $oldTime || $forceUpdate) {
			self::$options['nextUpdateTime'] = $newTime;
			if (self::$options['updateType'] == 'list') {
				if (!empty(self::$options['list']) && !is_array(end(self::$options['list']))) {
					foreach (self::$options['list'] as $key => $value) {
						self::$options['list'][$key] = array('id'=>$value,'discount'=>0);
					}
				}
				$count = count(self::$options['list'])-1;
				if ($count > self::$options['listNum']) {
					$listNum = self::$options['listNum']+1;
				} else {
					$listNum = 0;
				}
				self::$options['currentProductId'] = self::$options['list'][$listNum]['id'];
				self::$options['listNum'] = $listNum;
			} else {
				self::$options['currentProductId'] = self::selectNewProduct(self::$options['updateType'], self::$options['currentProductId'], self::$options['cats']);
			}

			MG::setOption(array('option' => 'dailyProduct', 'value' => addslashes(serialize(self::$options))));
		}
		return self::$options;
	}

	static function calcDiscount($price, $oldPrice, $discount, $ignoreOldPriceConversion = false) {

		$convertOldPrice = false;

		if ($discount) {
			$oldPrice = $price;
			$convertOldPrice = true;
		}

		$price = MG::numberDeFormat($price);
		$oldPrice = MG::numberDeFormat($oldPrice);

		$newPrice = $price*((100-$discount)/100);
		
		if ($convertOldPrice && !$ignoreOldPriceConversion) {
			$oldPrice = MG::convertPrice($oldPrice);
		}

		$newPrice = round($newPrice,2);
		$oldPrice = round($oldPrice,2);

		return array('price' => $newPrice, 'oldPrice' => $oldPrice);
	}

	static function calcCurrentDiscount($price, $oldPrice) {
		$options = self::updateTimer();

		if (self::$options['updateType'] == 'list') {
			$discount = $options['list'][$options['listNum']]['discount'];
		} else {
			$discount = $options['randomDiscount'];
		}
		return self::calcDiscount($price, $oldPrice, $discount);
	}

	static function getCurrentDiscount() {
		$options = self::updateTimer();

		if (self::$options['updateType'] == 'list') {
			$discount = $options['list'][$options['listNum']]['discount'];
		} else {
			$discount = isset($options['randomDiscount'])?$options['randomDiscount']:0;
		}
		return $discount;
	}

	static function hook_getListByUserFilter($args) {
		if (MG::isAdmin()) {
			return $args['result'];
		}
		if (self::getCurrentDiscount()) {
			foreach ($args['result']['catalogItems'] as $key => $item) {
				if ($item['id'] == self::$options['currentProductId']) {
					$controller = MG::get('controller');
					if ($controller == 'controllers_index' || $controller == 'controllers_group') {
						$prices = self::calcCurrentDiscount($item['price_course'], $item['old_price']);
						$args['result']['catalogItems'][$key]['price_course'] = $prices['price'];
						$args['result']['catalogItems'][$key]['old_price'] = $prices['oldPrice'];
					}
				}
			}
		}
		return $args['result'];
	}

	static function hook_getProduct($args) {
		if (MG::isAdmin() || 
			(MG::get('controller')=="controllers_order" && 
				(isset($_POST['toOrder']) || URL::get('addOrderOk') || URL::getQueryParametr('pay') || URL::getQueryParametr('id'))
			)
		) {
			return $args['result'];
		}
		if (self::getCurrentDiscount() && $args['result']['id'] == self::$options['currentProductId']) {	
			if (
				$args['result']['old_price'] == 0 && 
				MG::get('dbCurrency') != MG::getSetting('currencyShopIso')
			) {
				$args['result']['old_price'] = $args['result']['price_course'];
			}

			$prices = self::calcCurrentDiscount($args['result']['price_course'], $args['result']['old_price'],1);

			$args['result']['price'] = $prices['price'];
			$args['result']['price_course'] = $prices['price'];
			$args['result']['old_price'] = $prices['oldPrice'];
		}
		return $args['result'];
	}

	static function hook_getList($args) {
		if (MG::isAdmin()) {
			return $args['result'];
		}
		if (self::getCurrentDiscount()) {
			foreach ($args['result']['catalogItems'] as $key => $item) {
				if ($item['id'] == self::$options['currentProductId']) {
					if (
						$item['old_price'] == 0 && 
						MG::get('dbCurrency') != MG::getSetting('currencyShopIso')
					) {
						$item['old_price'] = $item['price'];
					}

					$prices = self::calcCurrentDiscount($item['price'], $item['old_price']);
					$args['result']['catalogItems'][$key]['price_course'] = MG::numberFormat($prices['price']);
					$args['result']['catalogItems'][$key]['price'] = MG::numberFormat($prices['price']);
					$args['result']['catalogItems'][$key]['old_price'] = MG::numberFormat($prices['oldPrice']);
				}
			}
		}
		return $args['result'];
	}

	static function getInitialProductPrices() {
		$discount = self::getCurrentDiscount();
		if (!$discount) {
			return false;
		}

		if (!empty(self::$cache['initialProduct'])) {
			return self::$cache['initialProduct'];
		}

		$res = DB::query("SELECT `price_course`, `rate`, `cat_id`, `inside_cat`
							FROM `".PREFIX."product` p 
							LEFT JOIN `".PREFIX."category` c 
							ON p.`cat_id` = c.`id` 
							WHERE p.`id`= ".DB::quoteInt(self::$options['currentProductId']));
		if ($row = DB::fetchAssoc($res)) {
			self::$cache['initialProduct']['cat_id'] 			= $row['cat_id'];
			self::$cache['initialProduct']['inside_cat'] 		= $row['inside_cat'];

			self::$cache['initialProduct']['price_course'] 		= $row['price_course'];
			self::$cache['initialProduct']['cat_rate'] 			= $row['rate'];
			self::$cache['initialProduct']['price_w_rate']		= $row['price_course']*(1+$row['rate']);
			self::$cache['initialProduct']['price_w_discount']	= self::$cache['initialProduct']['price_w_rate']*((100-$discount)/100);
			self::$cache['initialProduct']['price_w_discount_wo_rate']	= $row['price_course']*((100-$discount)/100);
			return self::$cache['initialProduct'];
		}

		return false;
	}

	static function hook_modUserFilterNavigatorSql($args) {//результаты фильтра
		if (MG::isAdmin()) {
			return $args['result'];
		}
		if (!isset($_REQUEST['price_course'][0]) || !isset($_REQUEST['price_course'][1])) {
			return $args['result'];
		}
		$initPrices = self::getInitialProductPrices();
		if (empty($initPrices)) {
			return $args['result'];
		}

		if (//цена до и после скидки в диапазоне поиска - нечего менять
			(
				$initPrices['price_w_discount'] > $_REQUEST['price_course'][0] && 
				$initPrices['price_w_discount'] < $_REQUEST['price_course'][1]
			) &&
			(
				$initPrices['price_w_rate'] 	> $_REQUEST['price_course'][0] && 
				$initPrices['price_w_rate'] 	< $_REQUEST['price_course'][1]
			)
		) {
			return $args['result'];
		}
		if (//цена до и после скидки НЕ в диапазоне поиска - нечего менять
			!(
				$initPrices['price_w_discount'] > $_REQUEST['price_course'][0] && 
				$initPrices['price_w_discount'] < $_REQUEST['price_course'][1]
			) &&
			!(
				$initPrices['price_w_rate'] 	> $_REQUEST['price_course'][0] && 
				$initPrices['price_w_rate'] 	< $_REQUEST['price_course'][1]
			)
		) {
			return $args['result'];
		}
		if (//только цена ДО скидки в диапазоне поиска - убрать лишнее
			!(
				$initPrices['price_w_discount'] > $_REQUEST['price_course'][0] && 
				$initPrices['price_w_discount'] < $_REQUEST['price_course'][1]
			) &&
			(
				$initPrices['price_w_rate'] 	> $_REQUEST['price_course'][0] && 
				$initPrices['price_w_rate'] 	< $_REQUEST['price_course'][1]
			)
		) {
			return str_replace(
				'((p.price_course', 
				'p.id <> '.DB::quoteInt(self::$options['currentProductId']).' AND ((p.price_course', 
				$args['result']
			);
		}
		
		if (//только цена ПОСЛЕ скидки в диапазоне поиска - добавить
			(
				$initPrices['price_w_discount'] > $_REQUEST['price_course'][0] && 
				$initPrices['price_w_discount'] < $_REQUEST['price_course'][1]
			) &&
			!(
				$initPrices['price_w_rate'] 	> $_REQUEST['price_course'][0] && 
				$initPrices['price_w_rate'] 	< $_REQUEST['price_course'][1]
			)
		) {
			return str_replace(
				'((p.price_course', 
				'p.id = '.DB::quoteInt(self::$options['currentProductId']).' OR ((p.price_course', 
				$args['result']
			);
		}

		return $args['result'];
	}

	static function hook_modFilterMinMaxPrices($args) {//мин/макс цена в фильтре
		if (MG::isAdmin()) {
			return $args['result'];
		}
		$initPrices = self::getInitialProductPrices();
		if (empty($initPrices)) {
			return $args['result'];
		}
		if ($args['result']['min'] > $initPrices['price_w_discount']) {
			$args['result']['min'] = floor($initPrices['price_w_discount']);
		}
		if ($args['result']['max'] < $initPrices['price_w_discount']) {
			$args['result']['max'] = ceil($initPrices['price_w_discount']);
		}
		return $args['result'];
	}
        
        
        // Хук выполняет перерасчет стоимости, товара в корзине cart и order
        static function hook_getItemsCart($args) {
            if (MG::isAdmin()) {
                return $args['result'];
            }
            foreach ($_SESSION['cart'] as $key => $item) {
                if ($item['id'] == self::$options['currentProductId']) {
				$initPrices = self::getInitialProductPrices();
                                $price = MG::convertPrice($initPrices['price_w_discount_wo_rate']);
                                $_SESSION['cart'][$key]['priceWithDiscount'] = $price;
				$_SESSION['cart'][$key]['priceWithCoupon'] = $price;
                }
                if($args['args'][0]['product']['id']==$_SESSION['cart'][$key]['id']){
                  if(!empty($_SESSION['cart'][$key]['priceWithCoupon'])){
                      $args['result'] = $_SESSION['cart'][$key]['priceWithCoupon'];
                  }
              }
            }
            
            return $args['result'];
        }
        
	static function hook_getTotalSumm($args) {
 
		if (MG::isAdmin()) {
			return $args['result'];
		}
                
		if (!URL::isSection('order')) {
			return $args['result'];
		}
                  
		if (empty($_SESSION['cart']) || !is_array($_SESSION['cart'])) {
			return $args['result'];
		}

		$initPrices = self::getInitialProductPrices();
 
		if (empty($initPrices) || empty(self::$options['ignoreDiscounts']) || self::$options['ignoreDiscounts'] != 'true') {
			return $args['result'];
		}

		$summ = 0;

		foreach ($_SESSION['cart'] as $key => $item) {
			if ($item['id'] == self::$options['currentProductId']) {
				$price = MG::convertPrice($initPrices['price_w_discount_wo_rate']);
                                
				$_SESSION['cart'][$key]['priceWithDiscount'] = $price;
				$_SESSION['cart'][$key]['priceWithCoupon'] = $price;
			}
			
			$price = $_SESSION['cart'][$key]['priceWithDiscount'];
			$price = $price + ($price*$_SESSION['price_rate']);
			$price = $price*100;
			$price = ceil($price);
			$price = $price/100;
			$price = $price * $_SESSION['cart'][$key]['count'];
                        $summ += $price;
		}

                $args['result'] = $summ;
                return $args['result'];
	}

	static function hook_applyDiscountSystem($args) {
		if (MG::isAdmin()) {
			return $args['result'];
		}
		$initPrices = self::getInitialProductPrices();
		if (empty($initPrices) || empty(self::$options['ignoreDiscounts']) || self::$options['ignoreDiscounts'] != 'true') {
			return $args['result'];
		}
                
		foreach ($args['args'] as $value) {
			if (!is_array($value)) {continue;}
			if (!empty($value['id']) && $value['id'] == self::$options['currentProductId']) {
				$args['result']['price'] = MG::convertPrice($initPrices['price_w_discount']);
				$args['result']['discounts'] = '';
				$args['result']['promo'] = '';
			}
		}
		return $args['result'];
	}

	static function hook_applyCoupon($args) {
		if (MG::isAdmin()) {
			return $args['result'];
		}
		$initPrices = self::getInitialProductPrices();
		if (empty($initPrices) || empty(self::$options['ignoreDiscounts']) || self::$options['ignoreDiscounts'] != 'true') {
			return $args['result'];
		}
		foreach ($args['args'] as $value) {
			if (!empty($value['id']) && $value['id'] == self::$options['currentProductId']) {
				$conv = MG::convertPrice($initPrices['price_w_discount']);
				if ($conv < $args['result']) {
					$args['result'] = $conv;
				}
			}
		}
		return $args['result'];
	}
}
?>